;################################################################################
;#										#
;# single chip basic computer with ATmega644	remote loader			#
;# copyright (c) 2006-2010 Joerg Wolfram (joerg@jcwolfram.de)			#
;#										#
;#										#
;# This program is free software; you can redistribute it and/or		#
;# modify it under the terms of the GNU General Public License as 		#
;# published by the Free Software Foundation; either version 3 of		#
;# the License, or (at your option) any later version.				#
;#										#
;# This library is distributed in the hope that it will be useful,		#
;# but WITHOUT ANY WARRANTY; without even the implied warranty of		#
;# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU		#
;# General Public License for more details.					#
;#										#
;# You should have received a copy of the GNU General Public			#
;# License along with this library; if not, write to the			#
;# Free Software Foundation, Inc., 59 Temple Place - Suite 330,			#
;# Boston, MA 02111-1307, USA.							#
;#										#
;################################################################################
		.db "Extens ion  N",0xf4,0x70,0xff	;green, library
		.db 0x07,0x03,0x03,0x0b,"XBAS",0x0d,0x0c,0x0c,0x0e
;dummy Funktion
.ORG	0x6610
ft_start:
		ldi	ctrl,0
		movw	YL,ZL
		ldi	ZL,LOW(ft_ctab*2)
		ldi	ZH,HIGH(ft_ctab*2)
		ldi	tempreg3,9
		call	api_tparser
		movw	r14,YL
		cpi	tempreg1,0
		breq	ft_nok
		cpi	tempreg1,1		;set sec
		brne	ft_sel_2
		rjmp	ft_ssec
ft_sel_2:	cpi	tempreg1,2		;set min
		brne	ft_sel_3
		rjmp	ft_smin
ft_sel_3:	cpi	tempreg1,3		;set hour
		brne	ft_sel_4
		rjmp	ft_shour
ft_sel_4:	cpi	tempreg1,4		;set day
		brne	ft_sel_5
		rjmp	ft_sday
ft_sel_5:	cpi	tempreg1,5		;set month
		brne	ft_sel_6
		rjmp	ft_smonth
ft_sel_6:	cpi	tempreg1,6		;set year
		brne	ft_sel_7
		rjmp	ft_syear

ft_sel_7:	cpi	tempreg1,7		;set sec
		brne	ft_sel_8
		rjmp	ft_gsec
ft_sel_8:	cpi	tempreg1,8		;set min
		brne	ft_sel_9
		rjmp	ft_gmin
ft_sel_9:	cpi	tempreg1,9		;set hour
		brne	ft_sel_a
		rjmp	ft_ghour
ft_sel_a:	cpi	tempreg1,10		;set day
		brne	ft_sel_b
		rjmp	ft_gday
ft_sel_b:	cpi	tempreg1,11		;set month
		brne	ft_sel_c
		rjmp	ft_gmonth
ft_sel_c:	cpi	tempreg1,12		;set year
		brne	ft_sel_d
		rjmp	ft_gyear
ft_sel_d:	ret

ft_ok:		clr	ereg
		ret

ft_nok:		ldi	ereg,8
		ret

ft_gsec:	call	api_basgetvar
		ldi	XL,0x01
		ldi	XH,0x00
		st	Y+,XL
		st	Y+,XH
		rjmp	ft_ok

ft_gmin:	call	api_basgetvar
		ldi	XL,0x02
		ldi	XH,0x00
		st	Y+,XL
		st	Y+,XH
		rjmp	ft_ok

ft_ghour:	call	api_basgetvar
		ldi	XL,0x03
		ldi	XH,0x00
		st	Y+,XL
		st	Y+,XH
		rjmp	ft_ok

ft_gday:	call	api_basgetvar
		ldi	XL,0x04
		ldi	XH,0x00
		st	Y+,XL
		st	Y+,XH
		rjmp	ft_ok

ft_gmonth:	call	api_basgetvar
		ldi	XL,0x05
		ldi	XH,0x00
		st	Y+,XL
		st	Y+,XH
		rjmp	ft_ok

ft_gyear:	call	api_basgetvar
		ldi	XL,0x06
		ldi	XH,0x00
		st	Y+,XL
		st	Y+,XH
		rjmp	ft_ok

ft_over:	ldi	ereg,2			;overflow
		ret

ft_ssec:	rcall	ft_value
		cpi	XL,60
		brcc	ft_over
		
		ret

ft_smin:	rcall	ft_value
		cpi	XL,60
		brcc	ft_over
		
		ret

ft_shour:	rcall	ft_value
		cpi	XL,24
		brcc	ft_over
		
		ret

ft_sday:	rcall	ft_value
		cpi	XL,0
		breq	ft_over
		cpi	XL,32
		brcc	ft_over
		
		ret


ft_smonth:	rcall	ft_value
		cpi	XL,0
		breq	ft_over
		cpi	XL,13
		brcc	ft_over
		
		ret


ft_syear:	rcall	ft_value

		ret



ft_value:	ldi	XL,1
		ldi	XH,0
		call	api_basgetpar
		cpi	ereg,0
		brne	ft_value_e
		cpi	XL,1
		brcc	ft_value_1
		pop	ereg			;kill stack
		pop	ereg
		ldi	ereg,19
		ret
ft_value_1:	call	api_getpartab
		ld	XL,Y
ft_value_e:	ret


.ORG	0x6b80
ft_ctab:	.db	0x01,"SETSEC..."
		.db	0x02,"SETMIN..."
		.db	0x03,"SETHOUR.."
		.db	0x04,"SETDAY..."
		.db	0x05,"SETMONTH."
		.db	0x06,"SETYEAR.."
		.db	0x07,"GETSEC..."
		.db	0x08,"GETMIN..."
		.db	0x09,"GETHOUR.."
		.db	0x0a,"GETDAY..."
		.db	0x0b,"GETMONTH."
		.db	0x0c,"GETYEAR.."
		.db	0x00,"........."